/*
    ================================================================================
    N-PUZZLE BOARD GAME
    Copyright (c) Jarmo Pietiläinen (a.k.a. z0b) 2008-2013
    http://z0b.kapsi.fi
    --------------------------------------------------------------------------------
    This program is free software; you can redistribute it and/or modify it
    under the terms of the GNU General Public License version 2.

    This program is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
    more details.

    You should have received a copy of the GNU General Public License along with
    this program; if not, write to the Free Software Foundation, Inc., 51
    Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
    ================================================================================
*/

#ifndef _NPUZZLE_CONSOLE_H
#define _NPUZZLE_CONSOLE_H

#include <cstdio>

// the function bodies are conditionally compiled away in release mode
namespace console
{
    bool open(const wchar_t *title = L"Debug Messages");
    void close();
    bool isOpen();
    void clear();
}

// use this macro to print messages
#ifdef NO_DEBUG_CONSOLE
    #define dprintf(format, ...)
#else
    #include <cstdarg>
    #define dprintf(format, ...)  do { wprintf(L ## format, ## __VA_ARGS__); fflush(stdout); } while (0);
#endif

#endif
