/*
    ================================================================================
    N-PUZZLE BOARD GAME
    Copyright (c) Jarmo Pietiläinen (a.k.a. z0b) 2008-2013
    http://z0b.kapsi.fi
    --------------------------------------------------------------------------------
    This program is free software; you can redistribute it and/or modify it
    under the terms of the GNU General Public License version 2.

    This program is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
    more details.

    You should have received a copy of the GNU General Public License along with
    this program; if not, write to the Free Software Foundation, Inc., 51
    Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
    ================================================================================
*/

#ifndef _NPUZZLE_GLOBALS_H
#define _NPUZZLE_GLOBALS_H

#include <stdint.h>

// handy self-assignment handling macro
// http://www.parashift.com/c++-faq-lite/assignment-operators.html
#define SELF_ASSIGNMENT(n)      if (this == &(n)) return *this;

// reduces the auto_ptr<> typing redudancy... (t=type, p=ptr)
#define AUTOPTR(t, p)           auto_ptr<t> p(new t);

// computes the number of elements in static array 'a'
#define ARRAYSIZE(a)            (sizeof(a) / sizeof(a[0]))

#endif
