/*
    ================================================================================
    N-PUZZLE BOARD GAME
    Copyright (c) Jarmo Pietiläinen (a.k.a. z0b) 2008-2013
    http://z0b.kapsi.fi
    --------------------------------------------------------------------------------
    This program is free software; you can redistribute it and/or modify it
    under the terms of the GNU General Public License version 2.

    This program is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
    more details.

    You should have received a copy of the GNU General Public License along with
    this program; if not, write to the Free Software Foundation, Inc., 51
    Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
    ================================================================================
*/

#ifndef _NPUZZLE_OPTIONS_H
#define _NPUZZLE_OPTIONS_H

#include <string>
#include "globaldefs.h"

struct options_t {
    // general game settings
    uint32_t boardWidth, boardHeight;

    // board colors
    COLORREF boardBack, tileHigh, tileLow, tileBack, tileFore;

    // pad & size
    uint32_t padX1, padX2, padY1, padY2, tilePadX, tilePadY;
    float sizeTweak;

    // tile font
    std::wstring fontName;
    uint32_t fontSize;
    bool fontBold, fontItalic, fontUnderline;
};

// define all options in a global structure
extern options_t opt;

namespace options
{
    void reset();
    bool save(const std::wstring &path);
    void load(const std::wstring &path);

    // flags returned by edit(), tells which settings were changed
    enum { COLORS = 0x01, PADDING = 0x02, FONT = 0x04 };

    int edit(HWND owner);
};

#endif
